3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19 echo "Error: The notmuch test suite requires a bash version >= 4.0"
20 echo "due to use of associative arrays within the test suite."
21 echo "Please try again with a newer bash (or help us fix the"
22 echo "test suite to be more portable). Thanks."
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
30 # do not redirect again
32 *' --tee '*|*' --va'*)
34 BASE=test-results/$(basename "$0" .sh)
35 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36 echo $? > $BASE.exit) | tee $BASE.out
37 test "$(cat $BASE.exit)" = 0
42 # Keep the original TERM for say_color and test_emacs
45 # For repeatability, reset the environment to known value.
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
69 # Each test should start with something like this, after copyright notices:
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76 TERM=$ORIGINAL_TERM &&
79 tput bold >/dev/null 2>&1 &&
80 tput setaf 1 >/dev/null 2>&1 &&
81 tput sgr0 >/dev/null 2>&1
88 -d|--d|--de|--deb|--debu|--debug)
90 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
92 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94 -h|--h|--he|--hel|--help)
96 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
98 -q|--q|--qu|--qui|--quie|--quiet)
101 with_dashes=t; shift ;;
107 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108 valgrind=t; verbose=t; shift ;;
110 shift ;; # was handled already
112 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
115 echo "error: unknown test option '$1'" >&2; exit 1 ;;
119 if test -n "$color"; then
125 error) tput bold; tput setaf 1;; # bold red
126 skip) tput bold; tput setaf 2;; # bold green
127 pass) tput setaf 2;; # green
128 info) tput setaf 3;; # brown
129 *) test -n "$quiet" && return;;
139 test -z "$1" && test -n "$quiet" && return
147 say_color error "error: $*\n"
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
159 if test "$help" = "t"
161 echo "Tests ${test_description}"
165 echo $(basename "$0"): "Testing ${test_description}"
177 rm -rf "$TEST_TMPDIR"
178 if test -n "$GIT_EXIT_OK"
182 echo >&5 "FATAL: Unexpected exit with code $code"
188 # Note: TEST_TMPDIR *NOT* exported!
189 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
192 test_decode_color () {
193 sed -e 's/.\[1m/<WHITE>/g' \
194 -e 's/.\[31m/<RED>/g' \
195 -e 's/.\[32m/<GREEN>/g' \
196 -e 's/.\[33m/<YELLOW>/g' \
197 -e 's/.\[34m/<BLUE>/g' \
198 -e 's/.\[35m/<MAGENTA>/g' \
199 -e 's/.\[36m/<CYAN>/g' \
200 -e 's/.\[m/<RESET>/g'
212 sed -e 's/$/Q/' | tr Q '\015'
216 tr '\015' Q | sed -e 's/Q$//'
219 # Generate a new message in the mail directory, with a unique message
220 # ID and subject. The message is not added to the index.
222 # After this function returns, the filename of the generated message
223 # is available as $gen_msg_filename and the message ID is available as
226 # This function supports named parameters with the bash syntax for
227 # assigning a value to an associative array ([name]=value). The
228 # supported parameters are:
230 # [dir]=directory/of/choice
232 # Generate the message in directory 'directory/of/choice' within
233 # the mail store. The directory will be created if necessary.
237 # Store the message in file 'name'. The default is to store it
238 # in 'msg-<count>', where <count> is three-digit number of the
243 # Text to use as the body of the email message
245 # '[from]="Some User <user@example.com>"'
246 # '[to]="Some User <user@example.com>"'
247 # '[subject]="Subject of email message"'
248 # '[date]="RFC 822 Date"'
250 # Values for email headers. If not provided, default values will
251 # be generated instead.
253 # '[cc]="Some User <user@example.com>"'
254 # [reply-to]=some-address
255 # [in-reply-to]=<message-id>
256 # [references]=<message-id>
257 # [content-type]=content-type-specification
258 # '[header]=full header line, including keyword'
260 # Additional values for email headers. If these are not provided
261 # then the relevant headers will simply not appear in the
266 # Controls the message-id of the created message.
272 # This is our (bash-specific) magic for doing named parameters
273 local -A template="($@)"
274 local additional_headers
276 gen_msg_cnt=$((gen_msg_cnt + 1))
277 if [ -z "${template[filename]}" ]; then
278 gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
280 gen_msg_name=${template[filename]}
283 if [ -z "${template[id]}" ]; then
284 gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
286 gen_msg_id="${template[id]}"
289 if [ -z "${template[dir]}" ]; then
290 gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
292 gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
293 mkdir -p "$(dirname "$gen_msg_filename")"
296 if [ -z "${template[body]}" ]; then
297 template[body]="This is just a test message (#${gen_msg_cnt})"
300 if [ -z "${template[from]}" ]; then
301 template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
304 if [ -z "${template[to]}" ]; then
305 template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
308 if [ -z "${template[subject]}" ]; then
309 template[subject]="Test message #${gen_msg_cnt}"
312 if [ -z "${template[date]}" ]; then
313 template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
316 additional_headers=""
317 if [ ! -z "${template[header]}" ]; then
318 additional_headers="${template[header]}
319 ${additional_headers}"
322 if [ ! -z "${template[reply-to]}" ]; then
323 additional_headers="Reply-To: ${template[reply-to]}
324 ${additional_headers}"
327 if [ ! -z "${template[in-reply-to]}" ]; then
328 additional_headers="In-Reply-To: ${template[in-reply-to]}
329 ${additional_headers}"
332 if [ ! -z "${template[cc]}" ]; then
333 additional_headers="Cc: ${template[cc]}
334 ${additional_headers}"
337 if [ ! -z "${template[references]}" ]; then
338 additional_headers="References: ${template[references]}
339 ${additional_headers}"
342 if [ ! -z "${template[content-type]}" ]; then
343 additional_headers="Content-Type: ${template[content-type]}
344 ${additional_headers}"
347 # Note that in the way we're setting it above and using it below,
348 # `additional_headers' will also serve as the header / body separator
349 # (empty line in between).
351 cat <<EOF >"$gen_msg_filename"
352 From: ${template[from]}
354 Message-Id: <${gen_msg_id}>
355 Subject: ${template[subject]}
356 Date: ${template[date]}
357 ${additional_headers}
362 # Generate a new message and add it to the database.
364 # All of the arguments and return values supported by generate_message
365 # are also supported here, so see that function for details.
368 generate_message "$@" &&
369 notmuch new > /dev/null
372 # Deliver a message with emacs and add it to the database
374 # Uses emacs to generate and deliver a message to the mail store.
375 # Accepts arbitrary extra emacs/elisp functions to modify the message
376 # before sending, which is useful to doing things like attaching files
377 # to the message and encrypting/signing.
378 emacs_deliver_message ()
383 # before we can send a message, we have to prepare the FCC maildir
384 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
385 $TEST_DIRECTORY/smtp-dummy sent_message &
388 "(let ((message-send-mail-function 'message-smtpmail-send-it)
389 (smtpmail-smtp-server \"localhost\")
390 (smtpmail-smtp-service \"25025\"))
394 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
395 (message-goto-subject)
396 (insert \"${subject}\")
400 (message-send-and-exit))"
401 wait ${smtp_dummy_pid}
402 notmuch new >/dev/null
405 # Generate a corpus of email and add it to the database.
407 # This corpus is fixed, (it happens to be 50 messages from early in
408 # the history of the notmuch mailing list), which allows for reliably
409 # testing commands that need to operate on a not-totally-trivial
410 # number of messages.
414 if [ -d $TEST_DIRECTORY/corpus.mail ]; then
415 cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
417 cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
418 notmuch new >/dev/null
419 cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
423 test_begin_subtest ()
425 if [ -n "$inside_subtest" ]; then
426 exec 1>&6 2>&7 # Restore stdout and stderr
427 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
429 test_subtest_name="$1"
430 test_subtest_known_broken_=
431 # Remember stdout and stderr file descriptors and redirect test
432 # output to the previously prepared file descriptors 3 and 4 (see
434 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
435 exec 6>&1 7>&2 >&3 2>&4
439 # Pass test if two arguments match
441 # Note: Unlike all other test_expect_* functions, this function does
442 # not accept a test name. Instead, the caller should call
443 # test_begin_subtest before calling this function in order to set the
447 exec 1>&6 2>&7 # Restore stdout and stderr
449 test "$#" = 3 && { prereq=$1; shift; } || prereq=
451 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
455 if ! test_skip "$test_subtest_name"
457 if [ "$output" = "$expected" ]; then
458 test_ok_ "$test_subtest_name"
460 testname=$this_test.$test_count
461 echo "$expected" > $testname.expected
462 echo "$output" > $testname.output
463 test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
468 # Like test_expect_equal, but takes two filenames.
469 test_expect_equal_file ()
471 exec 1>&6 2>&7 # Restore stdout and stderr
473 test "$#" = 3 && { prereq=$1; shift; } || prereq=
475 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
479 if ! test_skip "$test_subtest_name"
481 if diff -q "$expected" "$output" >/dev/null ; then
482 test_ok_ "$test_subtest_name"
484 testname=$this_test.$test_count
485 cp "$output" $testname.output
486 cp "$expected" $testname.expected
487 test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
494 notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
497 notmuch_search_sanitize ()
499 sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
502 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
503 notmuch_show_sanitize ()
505 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
507 notmuch_show_sanitize_all ()
510 -e 's| filename:.*| filename:XXXXX|' \
511 -e 's| id:[^ ]* | id:XXXXX |'
514 notmuch_json_show_sanitize ()
516 sed -e 's|, |,\n |g' | \
518 -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
519 -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
522 # End of notmuch helper functions
524 # Use test_set_prereq to tell that a particular prerequisite is available.
525 # The prerequisite can later be checked for in two ways:
527 # - Explicitly using test_have_prereq.
529 # - Implicitly by specifying the prerequisite tag in the calls to
530 # test_expect_{success,failure,code}.
532 # The single parameter is the prerequisite tag (a simple word, in all
533 # capital letters by convention).
536 satisfied="$satisfied$1 "
540 test_have_prereq () {
549 # You are not expected to call test_ok_ and test_failure_ directly, use
550 # the text_expect_* functions instead.
553 if test "$test_subtest_known_broken_" = "t"; then
554 test_known_broken_ok_ "$@"
557 test_success=$(($test_success + 1))
558 say_color pass "%-6s" "PASS"
563 if test "$test_subtest_known_broken_" = "t"; then
564 test_known_broken_failure_ "$@"
567 test_failure=$(($test_failure + 1))
568 test_failure_message_ "FAIL" "$@"
569 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
573 test_failure_message_ () {
574 say_color error "%-6s" "$1"
577 echo "$@" | sed -e 's/^/ /'
578 if test "$verbose" != "t"; then cat test.output; fi
581 test_known_broken_ok_ () {
582 test_subtest_known_broken_=
583 test_fixed=$(($test_fixed+1))
584 say_color pass "%-6s" "FIXED"
588 test_known_broken_failure_ () {
589 test_subtest_known_broken_=
590 test_broken=$(($test_broken+1))
591 test_failure_message_ "BROKEN" "$@"
596 test "$debug" = "" || eval "$1"
601 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
604 eval >&3 2>&4 "$test_cleanup"
609 test_count=$(($test_count+1))
611 for skp in $NOTMUCH_SKIP_TESTS
613 case $this_test.$test_count in
618 if test -z "$to_skip" && test -n "$prereq" &&
619 ! test_have_prereq "$prereq"
625 test_subtest_known_broken_=
626 say_color skip >&3 "skipping test: $@"
627 say_color skip "%-6s" "SKIP"
637 test_subtest_known_broken () {
638 test_subtest_known_broken_=t
641 test_expect_success () {
642 test "$#" = 3 && { prereq=$1; shift; } || prereq=
644 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
648 if [ "$?" = 0 -a "$eval_ret" = 0 ]
657 test_expect_code () {
658 test "$#" = 4 && { prereq=$1; shift; } || prereq=
660 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
664 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
673 # test_external runs external test scripts that provide continuous
674 # test output about their progress, and succeeds/fails on
675 # zero/non-zero exit code. It outputs the test output on stdout even
676 # in non-verbose mode, and announces the external script with "* run
677 # <n>: ..." before running it. When providing relative paths, keep in
678 # mind that all scripts run in "trash directory".
679 # Usage: test_external description command arguments...
680 # Example: test_external 'Perl API' perl ../path/to/test.pl
682 test "$#" = 4 && { prereq=$1; shift; } || prereq=
684 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
687 if ! test_skip "$descr" "$@"
689 # Announce the script to reduce confusion about the
690 # test output that follows.
691 say_color "" " run $test_count: $descr ($*)"
692 # Run command; redirect its stderr to &4 as in
693 # test_run_, but keep its stdout on our stdout even in
700 test_failure_ "$descr" "$@"
705 # Like test_external, but in addition tests that the command generated
706 # no output on stderr.
707 test_external_without_stderr () {
708 # The temporary file has no (and must have no) security
710 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
711 stderr="$tmp/git-external-stderr.$$.tmp"
712 test_external "$@" 4> "$stderr"
713 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
714 descr="no stderr: $1"
716 if [ ! -s "$stderr" ]; then
720 if [ "$verbose" = t ]; then
721 output=`echo; echo Stderr is:; cat "$stderr"`
725 # rm first in case test_failure exits.
727 test_failure_ "$descr" "$@" "$output"
731 # This is not among top-level (test_expect_success)
732 # but is a prefix that can be used in the test script, like:
734 # test_expect_success 'complain and die' '
736 # do something else &&
737 # test_must_fail git checkout ../outerspace
740 # Writing this as "! git checkout ../outerspace" is wrong, because
741 # the failure could be due to a segv. We want a controlled failure.
745 test $? -gt 0 -a $? -le 129 -o $? -gt 192
748 # test_cmp is a helper function to compare actual and expected output.
749 # You can use it like:
751 # test_expect_success 'foo works' '
752 # echo expected >expected &&
754 # test_cmp expected actual
757 # This could be written as either "cmp" or "diff -u", but:
758 # - cmp's output is not nearly as easy to read as diff -u
759 # - not all diff versions understand "-u"
765 # This function can be used to schedule some commands to be run
766 # unconditionally at the end of the test to restore sanity:
768 # test_expect_success 'test core.capslock' '
769 # git config core.capslock true &&
770 # test_when_finished "git config --unset core.capslock" &&
774 # That would be roughly equivalent to
776 # test_expect_success 'test core.capslock' '
777 # git config core.capslock true &&
779 # git config --unset core.capslock
782 # except that the greeting and config --unset must both succeed for
785 test_when_finished () {
787 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
792 test_results_dir="$TEST_DIRECTORY/test-results"
793 mkdir -p "$test_results_dir"
794 test_results_path="$test_results_dir/${0%.sh}-$$"
796 echo "total $test_count" >> $test_results_path
797 echo "success $test_success" >> $test_results_path
798 echo "fixed $test_fixed" >> $test_results_path
799 echo "broken $test_broken" >> $test_results_path
800 echo "failed $test_failure" >> $test_results_path
801 echo "" >> $test_results_path
805 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
807 if [ "$test_failure" = "0" ]; then
808 if [ "$test_broken" = "0" ]; then
817 emacs_generate_script () {
818 # Construct a little test script here for the benefit of the user,
819 # (who can easily run "run_emacs" to get the same emacs environment
820 # for investigating any failures).
821 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
824 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
826 # Here's what we are using here:
828 # --no-init-file Don't load users ~/.emacs
830 # --no-site-file Don't load the site-wide startup stuff
832 # --directory Ensure that the local elisp sources are found
834 # --load Force loading of notmuch.el and test-lib.el
836 exec emacs --no-init-file --no-site-file \
837 --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
838 --directory "$TEST_DIRECTORY" --load test-lib.el \
841 chmod a+x "$TMP_DIRECTORY/run_emacs"
845 if [ -z "$EMACS_SERVER" ]; then
846 EMACS_SERVER="notmuch-test-suite-$$"
847 # start a detached session with an emacs server
848 # user's TERM is given to dtach which assumes a minimally
849 # VT100-compatible terminal -- and emacs inherits that
850 TERM=$ORIGINAL_TERM dtach -n "$TMP_DIRECTORY/emacs-dtach-socket.$$" \
851 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
853 --eval '(setq server-name \"$EMACS_SERVER\")' \
854 --eval '(server-start)' \
855 --eval '(orphan-watchdog $$)'" || return
856 # wait until the emacs server is up
857 until test_emacs '()' 2>/dev/null; do
862 emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
870 while [ -n "$dir" ]; do
872 if [ -x "$bin" ]; then
876 dir="$(dirname "$dir")"
877 if [ "$dir" = "/" ]; then
883 # Test the binaries we have just built. The tests are kept in
884 # test/ subdirectory and are run in 'trash directory' subdirectory.
885 TEST_DIRECTORY=$(pwd)
886 if test -n "$valgrind"
890 test "$1" = "$(readlink "$2")" || {
898 while test -d "$2".lock
900 say "Waiting for lock on $2."
907 make_valgrind_symlink () {
908 # handle only executables
909 test -x "$1" || return
911 base=$(basename "$1")
912 symlink_target=$TEST_DIRECTORY/../$base
913 # do not override scripts
914 if test -x "$symlink_target" &&
915 test ! -d "$symlink_target" &&
916 test "#!" != "$(head -c 2 < "$symlink_target")"
918 symlink_target=$TEST_DIRECTORY/valgrind.sh
922 symlink_target=$TEST_DIRECTORY/unprocessed-script
924 # create the link, or replace it if it is out of date
925 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
928 # override notmuch executable in TEST_DIRECTORY/..
929 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
930 mkdir -p "$GIT_VALGRIND"/bin
931 make_valgrind_symlink $TEST_DIRECTORY/../notmuch
936 ls "$path"/notmuch 2> /dev/null |
939 make_valgrind_symlink "$file"
943 PATH=$GIT_VALGRIND/bin:$PATH
944 GIT_EXEC_PATH=$GIT_VALGRIND/bin
947 notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
948 test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
953 test="tmp.$(basename "$0" .sh)"
954 test -n "$root" && test="$root/$test"
956 /*) TMP_DIRECTORY="$test" ;;
957 *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
959 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
962 echo >&5 "FATAL: Cannot prepare test area"
966 # A temporary home directory is needed by at least:
967 # - emacs/"Sending a message via (fake) SMTP"
968 # - emacs/"Reply within emacs"
969 # - crypto/emacs_deliver_message
970 export HOME="${TMP_DIRECTORY}/home"
973 MAIL_DIR="${TMP_DIRECTORY}/mail"
974 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
975 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
978 mkdir -p "${MAIL_DIR}"
980 cat <<EOF >"${NOTMUCH_CONFIG}"
985 name=Notmuch Test Suite
986 primary_email=test_suite@notmuchmail.org
987 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
990 emacs_generate_script
993 # Use -P to resolve symlinks in our working directory so that the cwd
994 # in subprocesses like git equals our $PWD (for pathname comparisons).
995 cd -P "$test" || error "Cannot setup test environment"
997 if test "$verbose" = "t"
1001 exec 4>test.output 3>&4
1005 for skp in $NOTMUCH_SKIP_TESTS
1008 for skp in $NOTMUCH_SKIP_TESTS
1010 case "$this_test" in
1017 say_color skip >&3 "skipping test $this_test altogether"
1018 say_color skip "skip all tests in $this_test"
1023 # Provide an implementation of the 'yes' utility
1038 # Fix some commands on Windows
1041 # Windows has its own (incompatible) sort and find
1051 # git sees Windows-style pwd
1055 # no POSIX permissions
1056 # backslashes in pathspec are converted to '/'
1057 # exec does not inherit the PID
1060 test_set_prereq POSIXPERM
1061 test_set_prereq BSLASHPSPEC
1062 test_set_prereq EXECKEEPSPID
1066 test -z "$NO_PERL" && test_set_prereq PERL
1067 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1069 # test whether the filesystem supports symbolic links
1070 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS